From da64fe05978a9d0479d6d75f480f19d8d9ef0a1f Mon Sep 17 00:00:00 2001
From: Cedric Bosdonnat <cbosdonnat@suse.com>
Date: Wed, 10 Jun 2020 14:24:49 +0200
Subject: [PATCH] Opensuse 3000.2 virt backports (#236)

* Revert "virt._get_domain: don't raise an exception if there is no VM"

This reverts commit 9d433776fc252ab872b331cfa7fc940c42452f83.

* Revert "openSUSE-3000 virt-defined-states (#222)"

This reverts commit 900fdc4d5bcfdac933f9a411d38b92ef47dd1ef5.

* Revert "Add virt.all_capabilities"

This reverts commit 96e8307b531f7e51f5587f66a51dc52ad246c8c1.

* Blacken salt -- virt only

* virt._get_domain: don't raise an exception if there is no VM

Raising an exception if there is no VM in _get_domain makes sense if
looking for some VMs, but not when listing all VMs.

* fixed bug on update existing boot parameters

* add support to boot vm with UEFI

* virt: don't depend on ElementTree.tostring to compare XML fragments

ElementTree.tostring() implementation starts to keep the attribute order
defined by the user in python 3.8. This can lead to equal elements to be
considered different. Use xmlutil.to_dict(element, True) to compare the
elements.

This also uncovered a wrong behavior of pool_update when only changing
the password.

* openSUSE-3000 virt-defined-states (#222)

* Create virt.pool_defined state out of virt.pool_running

Users may want to use states to ensure a virtual storage pool is defined
and not enforce it to be running. Extract the code that performs the
pool definition / update from virt.pool_running state into a
virt.pool_defined.

Obviously the virt.pool_running state calls the virt.pool_defined one.
In such a case no additionnal test is needed for virt.pool_defined since
this is already tested with virt.pool_running.

* Add virt.update test parameter

In order to allow running dry-runs of virt.update module add a test
parameter. This will later be used by the virt states.

* Extract virt.defined state from virt.running

In order to ensure a virtual guest is defined independently of its
status, extract the corresponding code from the virt.running state.

This commit also handles the __opts__['test'] for the running state.
Since the update call only performs changes if needed, deprecate the
update parameter.

* Extract virt.network_defined from virt.network_running

Just like domains and storage pools, users may want to ensure a network
is defined without influencing it's status. Extract the code from
network_running state defining the network into a network_defined state.

While at it, support __opt__['test'] == True in these states. Updating
the network definition in the pool_defined state will come in a future
PR.

* Fix virt.update to handle None mem and cpu

virt.running state now may call virt.update with None mem and cpu
parameters. This was not handled in _gen_xml(). Also add some more tests
cases matching this for virt.update.

* Add support to virt for libvirt loader

* Add bhyve compatibility to virt

* Fix test_get_hypervisor: mock bhyve

* Add virt.all_capabilities

In order to get all possible capabilities from a host, the user has to
call virt.capabilities, and then loop over the guests and domains
before calling virt.domain_capabilities for each of them.

This commit embeds all this logic to get them all in a single
virt.all_capabilities call.

* Virt init disks support (PR#56666)

* Fix pylint warning in test_virt.py after blackening

* Add pool parameter to virt.define_vol_xml_str

* Remove useless default values for disks and vm_name in _disk_profile

* virt._gen_vol_xml: move all esx-specifics outside

In the near future gen_vol_xml will be able to handle many volume types,
not only for ESX volumes. For this, clean up the function from all the
ESX-specifics code and move them to the caller code.

The volume key and target path values have also been removed since those
are read-only elements that should not be provided for volume creation
as per https://libvirt.org/formatstorage.html#StorageVol

* virt: add more properties to generate volume XML

In order to generate almost all the volumes that libvirt can handle, add
the type, backingStore, permissions and allocation parameters to the
virt._gen_vol_xml() function.

Also make the format parameter optional since libvirt has default values
depending on the storage backend.

* virt.define_vol_xml_str variant using an existing libvirt connection

In order to avoid connection multiple times when reusing this function
in the virt module, create _define_vol_xml_str not caring about the
connection opening and closing.

* Add virt.volume_define function

In the same vein than pool_define and network_define, expose a
volume_define function to let users create a volume without needing to
know all of libvirt's XML details.

* Add virt.volume_upload function

When using volumes the user can just copy the template disk image into
the target path. In such a case, the image needs to be uploaded into the
volume.

* virt.capabilities refactoring

Extract the libvirt-handling code from virt.capabilities into a
virt._capabilities function accepting an opened libvirt connection.
This allows reusing the code in other functions with easy connection
handling.

* Extract virt.pool_capabilities logic for use with a libvirt connection

Te virt.pool_capabilities function computes a lot of interesting values
on the virtual storage pool types. Extract the logic of it into
virt._pool_capabilities for reuse.

* Share libvirt connection in virt.init

Since the next commits will introduce more uses of the libvirt
connection in virt.init(), start sharing it now.

* Add disk volumes support in virt.init

In order to support creating VMs with disk on more storage pools like
iSCSI, disks, LVM, RBD, etc, virt.init needs to handle disks not only as
files, but also as libvirt volumes.

* fix libvirtError use

libvirtError is not defined, libvirt.libvirtError should be used
instead.

* virt: let libvirt generate MAC addresses

There is no need to generate MAC addresses in the virt module if the
user hasn't provided any. This only makes it harder to make the
difference between a real mac address change from the user and a new
generated one.

Now the mac address is not written in the domain XML definition if not
provided by the user. This avoids unnecessary changes when applying
virt.running.

* virt.update handle disk volumes

* virt.volume_infos: output backing store as well

Since it could be useful to know whether a volume has a backing store,
output the path and format of the backing store if any is defined.

* virt.volume_infos: output disk format

Since the format of a volume may be of interest and could help to tell
if two volumes are similar, output this information in the
virt.volume_infos function.

* Add virt.volume_defined state

In order to help creating storage volumes in virtual storage pools from
states, add a virt.volume_defined state.

* Add volume support to virt._get_disks

If a virtual machine has disks of volume types, they will now be
reported by the virt._get_disk() function and all the user-exposed
functions using it like virt.get_disks(), virt.vm_info() and
virt.full_info().

* Add volume disks support to virt.purge()

virt.purge will now remove not only the file disks, but also the disk volumes.

* Handle RBD volumes as network disks in VM definition

libvirt doesn't support attaching RBD storage pool volumes to a VM.
For instance, a disk with such a source is invalid:

    <source pool='rbd-pool' volume='rbd-volume'/>

And needs to be replaced with:

    <source protocol="rbd" name="rbd-pool-name/rbd-volume">
      <host name="hostname" port="7000"/>
      <auth username='myuser'>
        <secret type='ceph' usage='mypassid'/>
      </auth>
    </source>

This means that we need to fetch the connection data from the pool
definition and convert the volume disk definition into a network one
when creating the VM.

This also means that when purging the VM we need to search for the
pool by looking in every pool's XML to delete the volume.

* virt: fix VM creating with disk volume

Since volumes in a virtual storage pool of type 'disk' are partitions,
then need to be named after the disk name with sequential numbers rather
than using the VM and disk names.

Also, the format passed by the user is the one used when creating the volume.
However in the VM definition for logical and disk volumes, the format should
be set to raw.

* virt: handle cdrom remote images

Libvirt allows to use network images for cdroms. Use them if the image
is a remote URL for a cdrom device.

* virt.update properly handle removable devices

Live attaching / detaching removable devices results in failures.
To change the source of those, we need to call updateDeviceFlags instead.

* improve boot parameter documentation (PR#57086)

* Remove buggy start parameter from virt.pool_running docstring

As mentioned by issue #57275, the start parameter in virt.pool_running
documentation is not implemented at all. Remove it from the doc.

* virt: fix removable_changes definition place

* virt: show the proper pool name in get_disks

From the user point of view the internal RBD pool name doesn't make
sense when listing the disks of a VM. We need then to resolve it to the
libvirt pool name if possible.

Move the corresponding code from purge to get_disks.

* virt: fix updating VM with backing store disks

libvirt adds the index attribute in the XML definition when there is a
backing store file for a disk. We need to elude it before comparing the
sources to avoid trying to recreate disks in such cases.

* virt: default cdrom model to ide

cdrom devices can't use virtio. Set the default bus to ide for cdroms.

* virt.get_disk: output the full URL for cdroms with remote image

virt._gen_xml converts the cdroms with remote URL into a network device,
but to be coherent with the user input the virt.get_disk() function
needs to reassemble the URL in thoses cases.

* virt.pool_delete: remove also secret

Some pool type require a secret for the authentication on the remote
source. Remove the secrets that were added by pool_defined but leave the
others in place.

* virt.init: cdrom format default to raw

cdrom sources can't be of format qcow2. Force raw as the default if
needed when creating VM with source_file set for the cdrom.

* virt.init: fix disk target names

Fixes issue #57477.

* virt.update: handle changing cdrom images for devices with remote source

When a DVD device on a VM has a remote source, virt.update needs to be
able to handle detaching it and attaching a file image live.

* virt.init: fix the name of volumes reused in disk-types pools

Only compute the partition name if no source_file was provided by the
user for a pool of disk type.

Co-authored-by: Blacken Salt <jenkins@saltstack.com>
Co-authored-by: Firefly <leevn2011@hotmail.com>
Co-authored-by: Jeroen Schutrup <jeroenschutrup@hotmail.nl>
Co-authored-by: ch3ll <megan.wilhite@gmail.com>
---
 changelog/57005.added                    |    1 +
 changelog/57275.fixed                    |    1 +
 changelog/57477.fixed                    |    1 +
 changelog/57497.fixed                    |    1 +
 salt/modules/virt.py                     | 4756 ++++++++++--------
 salt/states/virt.py                      | 1440 +++---
 salt/templates/virt/libvirt_domain.jinja |   29 +-
 salt/templates/virt/libvirt_volume.jinja |   40 +-
 tests/unit/modules/test_virt.py          | 5564 +++++++++++++++-------
 tests/unit/states/test_virt.py           | 4638 +++++++++++-------
 10 files changed, 10558 insertions(+), 5913 deletions(-)
 create mode 100644 changelog/57005.added
 create mode 100644 changelog/57275.fixed
 create mode 100644 changelog/57477.fixed
 create mode 100644 changelog/57497.fixed

diff --git a/changelog/57005.added b/changelog/57005.added
new file mode 100644
index 0000000000..6704541509
--- /dev/null
+++ b/changelog/57005.added
@@ -0,0 +1 @@
+Add support for disks volumes in virt.running state
diff --git a/changelog/57275.fixed b/changelog/57275.fixed
new file mode 100644
index 0000000000..6efbe48315
--- /dev/null
+++ b/changelog/57275.fixed
@@ -0,0 +1 @@
+Remove buggy start parameter from virt.pool_running docstring
diff --git a/changelog/57477.fixed b/changelog/57477.fixed
new file mode 100644
index 0000000000..f32f32fdfc
--- /dev/null
+++ b/changelog/57477.fixed
@@ -0,0 +1 @@
+virt.init fix the disk target names
diff --git a/changelog/57497.fixed b/changelog/57497.fixed
new file mode 100644
index 0000000000..24697e108d
--- /dev/null
+++ b/changelog/57497.fixed
@@ -0,0 +1 @@
+Fix volume name for disk-typed pools in virt.defined
diff --git a/salt/modules/virt.py b/salt/modules/virt.py
index c8e046a47a..a78c21e323 100644
--- a/salt/modules/virt.py
+++ b/salt/modules/virt.py
@@ -1,5 +1,5 @@
 # -*- coding: utf-8 -*-
-'''
+"""
 Work with virtual machines managed by libvirt
 
 :depends: libvirt Python module
@@ -68,7 +68,7 @@ The calls not using the libvirt connection setup are:
 - `libvirt URI format <http://libvirt.org/uri.html#URI_config>`_
 - `libvirt authentication configuration <http://libvirt.org/auth.html#Auth_client_config>`_
 
-'''
+"""
 # Special Thanks to Michael Dehann, many of the concepts, and a few structures
 # of his in the virt func module have been used
 
@@ -76,26 +76,21 @@ The calls not using the libvirt connection setup are:
 from __future__ import absolute_import, print_function, unicode_literals
 import base64
 import copy
+import datetime
+import logging
 import os
 import re
-import sys
 import shutil
-import subprocess
 import string  # pylint: disable=deprecated-module
-import logging
+import subprocess
+import sys
 import time
-import datetime
 from xml.etree import ElementTree
+from xml.sax import saxutils
 
 # Import third party libs
 import jinja2
 import jinja2.exceptions
-try:
-    import libvirt  # pylint: disable=import-error
-    from libvirt import libvirtError
-    HAS_LIBVIRT = True
-except ImportError:
-    HAS_LIBVIRT = False
 
 # Import salt libs
 import salt.utils.files
@@ -106,49 +101,65 @@ import salt.utils.stringutils
 import salt.utils.templates
 import salt.utils.validate.net
 import salt.utils.versions
+import salt.utils.xmlutil as xmlutil
 import salt.utils.yaml
-
-from salt.utils.virt import check_remote, download_remote
+from salt._compat import ipaddress
 from salt.exceptions import CommandExecutionError, SaltInvocationError
 from salt.ext import six
 from salt.ext.six.moves import range  # pylint: disable=import-error,redefined-builtin
-from salt._compat import ipaddress
+from salt.ext.six.moves.urllib.parse import urlparse, urlunparse
+from salt.utils.virt import check_remote, download_remote
+
+try:
+    import libvirt  # pylint: disable=import-error
+
+    # pylint: disable=no-name-in-module
+    from libvirt import libvirtError
+
+    # pylint: enable=no-name-in-module
+
+    HAS_LIBVIRT = True
+except ImportError:
+    HAS_LIBVIRT = False
+
 
 log = logging.getLogger(__name__)
 
 # Set up template environment
 JINJA = jinja2.Environment(
     loader=jinja2.FileSystemLoader(
-        os.path.join(salt.utils.templates.TEMPLATE_DIRNAME, 'virt')
+        os.path.join(salt.utils.templates.TEMPLATE_DIRNAME, "virt")
     )
 )
 
-CACHE_DIR = '/var/lib/libvirt/saltinst'
+CACHE_DIR = "/var/lib/libvirt/saltinst"
 
-VIRT_STATE_NAME_MAP = {0: 'running',
-                       1: 'running',
-                       2: 'running',
-                       3: 'paused',
-                       4: 'shutdown',
-                       5: 'shutdown',
-                       6: 'crashed'}
+VIRT_STATE_NAME_MAP = {
+    0: "running",
+    1: "running",
+    2: "running",
+    3: "paused",
+    4: "shutdown",
+    5: "shutdown",
+    6: "crashed",
+}
 
 
 def __virtual__():
     if not HAS_LIBVIRT:
-        return (False, 'Unable to locate or import python libvirt library.')
-    return 'virt'
+        return (False, "Unable to locate or import python libvirt library.")
+    return "virt"
 
 
 def __get_request_auth(username, password):
-    '''
+    """
     Get libvirt.openAuth callback with username, password values overriding
     the configuration ones.
-    '''
+    """
 
     # pylint: disable=unused-argument
     def __request_auth(credentials, user_data):
-        '''Callback method passed to libvirt.openAuth().
+        """Callback method passed to libvirt.openAuth().
 
         The credentials argument is a list of credentials that libvirt
         would like to request. An element of this list is a list containing
@@ -160,21 +171,31 @@ def __get_request_auth(username, password):
           - a place to store the actual result for the request
 
         The user_data argument is currently not set in the openAuth call.
-        '''
+        """
         for credential in credentials:
             if credential[0] == libvirt.VIR_CRED_AUTHNAME:
-                credential[4] = username if username else \
-                                __salt__['config.get']('virt:connection:auth:username', credential[3])
+                credential[4] = (
+                    username
+                    if username
+                    else __salt__["config.get"](
+                        "virt:connection:auth:username", credential[3]
+                    )
+                )
             elif credential[0] == libvirt.VIR_CRED_NOECHOPROMPT:
-                credential[4] = password if password else \
-                                __salt__['config.get']('virt:connection:auth:password', credential[3])
+                credential[4] = (
+                    password
+                    if password
+                    else __salt__["config.get"](
+                        "virt:connection:auth:password", credential[3]
+                    )
+                )
             else:
-                log.info('Unhandled credential type: %s', credential[0])
+                log.info("Unhandled credential type: %s", credential[0])
         return 0
 
 
 def __get_conn(**kwargs):
-    '''
+    """
     Detects what type of dom this node is and attempts to connect to the
     correct hypervisor via libvirt.
 
@@ -182,99 +203,65 @@ def __get_conn(**kwargs):
     :param username: username to connect with, overriding defaults
     :param password: password to connect with, overriding defaults
 
-    '''
+    """
     # This has only been tested on kvm and xen, it needs to be expanded to
     # support all vm layers supported by libvirt
+    # Connection string works on bhyve, but auth is not tested.
 
-    username = kwargs.get('username', None)
-    password = kwargs.get('password', None)
-    conn_str = kwargs.get('connection', None)
+    username = kwargs.get("username", None)
+    password = kwargs.get("password", None)
+    conn_str = kwargs.get("connection", None)
     if not conn_str:
-        conn_str = __salt__['config.get']('virt.connect', None)
-        if conn_str is not None:
-            salt.utils.versions.warn_until(
-                'Sodium',
-                '\'virt.connect\' configuration property has been deprecated in favor '
-                'of \'virt:connection:uri\'. \'virt.connect\' will stop being used in '
-                '{version}.'
-            )
-        else:
-            conn_str = __salt__['config.get']('libvirt:connection', None)
-            if conn_str is not None:
-                salt.utils.versions.warn_until(
-                    'Sodium',
-                    '\'libvirt.connection\' configuration property has been deprecated in favor '
-                    'of \'virt:connection:uri\'. \'libvirt.connection\' will stop being used in '
-                    '{version}.'
-                )
-
-        conn_str = __salt__['config.get']('virt:connection:uri', conn_str)
-
-    hypervisor = __salt__['config.get']('libvirt:hypervisor', None)
-    if hypervisor is not None:
-        salt.utils.versions.warn_until(
-            'Sodium',
-            '\'libvirt.hypervisor\' configuration property has been deprecated. '
-            'Rather use the \'virt:connection:uri\' to properly define the libvirt '
-            'URI or alias of the host to connect to. \'libvirt:hypervisor\' will '
-            'stop being used in {version}.'
-        )
-
-    if hypervisor == 'esxi' and conn_str is None:
-        salt.utils.versions.warn_until(
-            'Sodium',
-            'esxi hypervisor default with no default connection URI detected, '
-            'please set \'virt:connection:uri\' to \'esx\' for keep the legacy '
-            'behavior. Will default to libvirt guess once \'libvirt:hypervisor\' '
-            'configuration is removed in {version}.'
-        )
-        conn_str = 'esx'
+        conn_str = __salt__["config.get"]("virt:connection:uri", conn_str)
 
     try:
-        auth_types = [libvirt.VIR_CRED_AUTHNAME,
-                      libvirt.VIR_CRED_NOECHOPROMPT,
-                      libvirt.VIR_CRED_ECHOPROMPT,
-                      libvirt.VIR_CRED_PASSPHRASE,
-                      libvirt.VIR_CRED_EXTERNAL]
-        conn = libvirt.openAuth(conn_str, [auth_types, __get_request_auth(username, password), None], 0)
+        auth_types = [
+            libvirt.VIR_CRED_AUTHNAME,
+            libvirt.VIR_CRED_NOECHOPROMPT,
+            libvirt.VIR_CRED_ECHOPROMPT,
+            libvirt.VIR_CRED_PASSPHRASE,
+            libvirt.VIR_CRED_EXTERNAL,
+        ]
+        conn = libvirt.openAuth(
+            conn_str, [auth_types, __get_request_auth(username, password), None], 0
+        )
     except Exception:  # pylint: disable=broad-except
         raise CommandExecutionError(
-            'Sorry, {0} failed to open a connection to the hypervisor '
-            'software at {1}'.format(
-                __grains__['fqdn'],
-                conn_str
-            )
+            "Sorry, {0} failed to open a connection to the hypervisor "
+            "software at {1}".format(__grains__["fqdn"], conn_str)
         )
     return conn
 
 
 def _get_domain(conn, *vms, **kwargs):
-    '''
+    """
     Return a domain object for the named VM or return domain object for all VMs.
 
     :params conn: libvirt connection object
     :param vms: list of domain names to look for
     :param iterable: True to return an array in all cases
-    '''
+    """
     ret = list()
     lookup_vms = list()
 
     all_vms = []
-    if kwargs.get('active', True):
+    if kwargs.get("active", True):
         for id_ in conn.listDomainsID():
             all_vms.append(conn.lookupByID(id_).name())
 
-    if kwargs.get('inactive', True):
+    if kwargs.get("inactive", True):
         for id_ in conn.listDefinedDomains():
             all_vms.append(id_)
 
     if vms and not all_vms:
-        raise CommandExecutionError('No virtual machines found.')
+        raise CommandExecutionError("No virtual machines found.")
 
     if vms:
         for name in vms:
             if name not in all_vms:
-                raise CommandExecutionError('The VM "{name}" is not present'.format(name=name))
+                raise CommandExecutionError(
+                    'The VM "{name}" is not present'.format(name=name)
+                )
             else:
                 lookup_vms.append(name)
     else:
@@ -283,52 +270,69 @@ def _get_domain(conn, *vms, **kwargs):
     for name in lookup_vms:
         ret.append(conn.lookupByName(name))
 
-    return len(ret) == 1 and not kwargs.get('iterable') and ret[0] or ret
+    return len(ret) == 1 and not kwargs.get("iterable") and ret[0] or ret
 
 
 def _parse_qemu_img_info(info):
-    '''
+    """
     Parse qemu-img info JSON output into disk infos dictionary
-    '''
+    """
     raw_infos = salt.utils.json.loads(info)
     disks = []
     for disk_infos in raw_infos:
         disk = {
-                   'file': disk_infos['filename'],
-                   'file format': disk_infos['format'],
-                   'disk size': disk_infos['actual-size'],
-                   'virtual size': disk_infos['virtual-size'],
-                   'cluster size': disk_infos['cluster-size'] if 'cluster-size' in disk_infos else None,
-               }
-
-        if 'full-backing-filename' in disk_infos.keys():
-            disk['backing file'] = format(disk_infos['full-backing-filename'])
-
-        if 'snapshots' in disk_infos.keys():
-            disk['snapshots'] = [
-                    {
-                        'id': snapshot['id'],
-                        'tag': snapshot['name'],
-                        'vmsize': snapshot['vm-state-size'],
-                        'date': datetime.datetime.fromtimestamp(
-                            float('{}.{}'.format(snapshot['date-sec'], snapshot['date-nsec']))).isoformat(),
-                        'vmclock': datetime.datetime.utcfromtimestamp(
-                            float('{}.{}'.format(snapshot['vm-clock-sec'],
-                                                 snapshot['vm-clock-nsec']))).time().isoformat()
-                    } for snapshot in disk_infos['snapshots']]
+            "file": disk_infos["filename"],
+            "file format": disk_infos["format"],
+            "disk size": disk_infos["actual-size"],
+            "virtual size": disk_infos["virtual-size"],
+            "cluster size": disk_infos["cluster-size"]
+            if "cluster-size" in disk_infos
+            else None,
+        }
+
+        if "full-backing-filename" in disk_infos.keys():
+            disk["backing file"] = format(disk_infos["full-backing-filename"])
+
+        if "snapshots" in disk_infos.keys():
+            disk["snapshots"] = [
+                {
+                    "id": snapshot["id"],
+                    "tag": snapshot["name"],
+                    "vmsize": snapshot["vm-state-size"],
+                    "date": datetime.datetime.fromtimestamp(
+                        float(
+                            "{}.{}".format(snapshot["date-sec"], snapshot["date-nsec"])
+                        )
+                    ).isoformat(),
+                    "vmclock": datetime.datetime.utcfromtimestamp(
+                        float(
+                            "{}.{}".format(
+                                snapshot["vm-clock-sec"], snapshot["vm-clock-nsec"]
+                            )
+                        )
+                    )
+                    .time()
+                    .isoformat(),
+                }
+                for snapshot in disk_infos["snapshots"]
+            ]
         disks.append(disk)
 
     for disk in disks:
-        if 'backing file' in disk.keys():
-            candidates = [info for info in disks if 'file' in info.keys() and info['file'] == disk['backing file']]
+        if "backing file" in disk.keys():
+            candidates = [
+                info
+                for info in disks
+                if "file" in info.keys() and info["file"] == disk["backing file"]
+            ]
             if candidates:
-                disk['backing file'] = candidates[0]
+                disk["backing file"] = candidates[0]
 
     return disks[0]
 
 
 def _get_uuid(dom):
-    '''
+    """
     Return a uuid from the named vm
 
     CLI Example:
@@ -336,12 +340,12 @@ def _get_uuid(dom):
     .. code-block:: bash
 
         salt '*' virt.get_uuid <domain>
-    '''
-    return ElementTree.fromstring(get_xml(dom)).find('uuid').text
+    """
+    return ElementTree.fromstring(get_xml(dom)).find("uuid").text
 
 
 def _get_on_poweroff(dom):
-    '''
+    """
     Return `on_poweroff` setting from the named vm
 
     CLI Example:
@@ -349,13 +353,13 @@ def _get_on_poweroff(dom):
     .. code-block:: bash
 
         salt '*' virt.get_on_restart <domain>
-    '''
-    node = ElementTree.fromstring(get_xml(dom)).find('on_poweroff')
-    return node.text if node is not None else ''
+    """
+    node = ElementTree.fromstring(get_xml(dom)).find("on_poweroff")
+    return node.text if node is not None else ""
 
 
 def _get_on_reboot(dom):
-    '''
+    """
     Return `on_reboot` setting from the named vm
 
     CLI Example:
@@ -363,13 +367,13 @@ def _get_on_reboot(dom):
     .. code-block:: bash
 
         salt '*' virt.get_on_reboot <domain>
-    '''
-    node = ElementTree.fromstring(get_xml(dom)).find('on_reboot')
-    return node.text if node is not None else ''
+    """
+    node = ElementTree.fromstring(get_xml(dom)).find("on_reboot")
+    return node.text if node is not None else ""
 
 
 def _get_on_crash(dom):
-    '''
+    """
     Return `on_crash` setting from the named vm
 
     CLI Example:
